using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_SistemaGestionAlmacen._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Linq;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_SistemaGestionAlmacen._3_Vistas
{
    public partial class P_Inventario_Cabecera : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_Inventario_Cabecera_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;
        #endregion

        #region Objetos en Pantalla

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Fecha { get { return ex_usc_P_Inventario_Cabecera_Fecha; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_Empleado { get { return ex_usc_F3_P_Inventario_Cabecera_Empleado; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_NumeroDocumento { get { return ex_lbl_P_Inventario_Cabecera_NumeroDocumento; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_Inventario_Cabecera_Descripcion; } }

        //Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Delegacion { get { return ex_lbl_P_Inventario_Cabecera_Delegacion; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Almacen { get { return ex_lbl_P_Inventario_Cabecera_Almacen; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_NumeroDocumento { get { return ex_txt_P_Inventario_Cabecera_NumeroDocumento; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_Inventario_Cabecera_Descripcion; } }

        //Exferia_RadioButton
        internal Exferia_RadioButton Exferia_RadioButton_Estado_EnCurso { get { return ex_rdb_P_Inventario_Cabecera_Estado_EnCurso; } }
        internal Exferia_RadioButton Exferia_RadioButton_Estado_Aparcado { get { return ex_rdb_P_Inventario_Cabecera_Estado_Aparcado; } }
        internal Exferia_RadioButton Exferia_RadioButton_Estado_Finalizado { get { return ex_rdb_P_Inventario_Cabecera_Estado_Finalizado; } }

        #endregion

        #region Constructor 
        public P_Inventario_Cabecera(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ............................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_Inventario_Cabecera_Controladora(this);

                //Datos de Opciones Detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Puedan poder bloqueados o solo de lectura
                ex_btn_P_Inventario_Cabecera_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_Inventario_Cabecera_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo  puede ver lod datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla ...........................................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Inventario_Cabecera) + "/" + nameof(P_Inventario_Cabecera));
                    }
                }
                //..........................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //..............................................................

                //Rellenar para los F3 ..........................................

                //Empleado -----------------------------
                ex_usc_F3_P_Inventario_Cabecera_Empleado.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_EMPLEADO;
                ex_usc_F3_P_Inventario_Cabecera_Empleado.Exferia_F3_PantallaContenedora = this;
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra el mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Inventario_Cabecera) + "/" + nameof(P_Inventario_Cabecera));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .......
                Enabled = true;
                //...............................................................
            }
        }
        #endregion

        #region Inicio de Pantalla
        private void P_Inventario_Cabecera_Load(object sender, EventArgs e)
        {
            try
            {}
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Inventario_Cabecera) + "/" + nameof(P_Inventario_Cabecera_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_Inventario_Cabecera_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    ActivarBotones(true);

                    g_obj_Controladora.RecargarDatos();
                    
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Inventario_Cabecera) + "/" + nameof(P_Inventario_Cabecera_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {

            if (ex_btn_P_Inventario_Cabecera_Borrar.Enabled)
            {
                ex_btn_P_Inventario_Cabecera_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Procedimientos heredados de la clase P_Base

        //Se utiliza para actualizar los listados dentro de la pantalla, sin tener que guardar
        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    P_Base_SeModificoDatosPantalla = true;

                    //Poner como que se modifico algo
                    P_Base_SeModificoDatosPantalla = true;
                }
            }
            catch (Exception ex)
            {
                Mensajes.MostrarMensaje(ex.Message);
            }
        }
        #endregion

        #region Botones Grabar,Borrar, BuscarCodigoSiguiente 
        private void ex_btn_P_Inventario_Cabecera_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Inventario_Cabecera_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_P_Inventario_Cabecera_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifico algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion


    }
}
